.686
.XMM

.MODEL FLAT, BORLAND
option casemap:none 

TXMMATRIX struct 16
	r0 XMMWORD ?
	r1 XMMWORD ?
	r2 XMMWORD ?
	r3 XMMWORD ?
TXMMATRIX ends

.const
fixupuint64 qword 43E0000000000000h

.code

; Add integer, smallint, byte and single. Return a integer
; function AddNumbersResInt(int1: integer; single1: single; word1: smallint; byte1: byte): integer; 
AddNumbersResInt proc public uses ebx int1:sdword, single1:real4, sword1:sword, byte1:byte
	movss xmm0, single1
	cvtss2si ebx, xmm0 ; convert to integer
	
	add int1, ebx
	movsx edx, sword1
	add int1, edx
	movzx ecx, byte1
	add int1, ecx
	ret
AddNumbersResInt endp

; Add integer, smallint, byte and single. Return a single
;function AddNumbersResSingle(int1: integer; single1: single; word1: smallint; byte1: byte): Single;
AddNumbersResSingle proc public int1:sdword, single1:real4, sword1:sword, byte1:byte
	LOCAL fResult : REAL4
	
	movss xmm1, single1
	cvtsi2ss xmm0, int1
	movsx edx, sword1
	cvtsi2ss xmm2, edx
	movzx ecx, byte1
	cvtsi2ss xmm3, ecx
	addss xmm0, xmm1
	addss xmm0, xmm2
	addss xmm0, xmm3
	movss fResult, xmm0
	fld fResult
	ret
AddNumbersResSingle endp

; Using 64 bit signed/unsigned integers and doubles
; function MulDivNumbersResDouble(num1 : int64; double1 : double; num2 : uint64):double;
; begin
; 	result:=(num1*double1)/num2;
; end
MulDivNumbersResDouble proc public num1 : sqword, double1 : real8, num2 :qword
	fild num1
	fmul double1
	sub dword ptr [num2+4], 080000000h ; unsigned 64bit fixup
	fild num2					
	fadd fixupuint64			     ; unsigned 64bit fixup	
	fdivp 
	ret
MulDivNumbersResDouble endp

; Using 64 bit signed/unsigned integers and doubles
; function MulDivNumbersResInt64(num1 : int64; double1 : double; num2 : uint64):Int64;
; begin
; 	result:=(num1*double1)/num2;
; end
MulDivNumbersResInt64 proc public num1 : sqword, double1 : real8, num2 :qword
	fild num1
	fmul double1
	sub dword ptr [num2+4], 080000000h ; unsigned 64bit fixup
	fild num2					
	fadd fixupuint64			     ; unsigned 64bit fixup	
	fdivp 
	sub esp, 8
	fistp qword ptr [esp]   ; round
	pop eax
	pop edx
	ret
MulDivNumbersResInt64 endp


XMVectorSet proc private x: REAL4, y: REAL4, z: REAL4, w: REAL4, retVal:ptr
	movss xmm0, x
	movss xmm1, y
	movss xmm2, z
	movss xmm3, w
	unpcklps    xmm0,xmm2  
	unpcklps    xmm1,xmm3 
	unpcklps    xmm0,xmm1 
	mov eax, retVal
	movups XMMWORD ptr [eax], xmm0
	ret
XMVectorSet endp

; Build 4x4 matrix of singles
XMMatrixSet proc public mm00: REAL4, mm01: REAL4, mm02: REAL4, mm03: REAL4, mm10: REAL4, mm11: REAL4, mm12: REAL4, mm13: REAL4, mm20: REAL4, mm21: REAL4, mm22: REAL4, mm23: REAL4, mm30: REAL4, mm31: REAL4, mm32: REAL4, mm33: REAL4, retVal : ptr
	mov edx, retVal
	ASSUME edx : ptr TXMMATRIX 	
	INVOKE XMVectorSet, mm00, mm01, mm02, mm03, addr [edx].r0
	INVOKE XMVectorSet, mm10, mm11, mm12, mm13, addr [edx].r1
	INVOKE XMVectorSet, mm20, mm21, mm22, mm23, addr [edx].r2
	INVOKE XMVectorSet, mm30, mm31, mm32, mm33, addr [edx].r3
	mov eax, edx
	ASSUME edx : NOTHING
	ret
XMMatrixSet endp


end

