unit testing;

interface

{$POINTERMATH ON}


uses
    Winapi.Windows, System.SysUtils, Winapi.Messages, System.Variants, System.Classes, Vcl.Graphics,
    Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
    TdemoForm = class(TForm)
        btGO: TButton;
        memo: TMemo;
        procedure btGOClick(Sender: TObject);
        procedure FormCreate(Sender: TObject);
    private
        { Private declarations }
    public
        { Public declarations }
    end;

    TFLOAT4 = array [0 .. 3] of single;

    XMVECTOR = record
        case integer of
            0:
                  (vector4_f32: TFLOAT4);
            1:
                  (vector4_u32: array [0 .. 3] of uint32);
            2:
                  (vector4_i32: array [0 .. 3] of int32);
    end;

    TXMMATRIX = record
        r: array [0 .. 3] of XMVECTOR;
    end;

var
    demoForm: TdemoForm;


{$L borland.obj}


function AddNumbersResInt(int1: integer; single1: single; word1: smallint; byte1: byte): integer; external;
function AddNumbersResSingle(int1: integer; single1: single; word1: smallint; byte1: byte): single; external;
function MulDivNumbersResDouble(num1: int64; double1: double; num2: uint64): double; external;
function MulDivNumbersResInt64(num1: int64; double1: double; num2: uint64): int64; external;
function XMMatrixSet(mm00, mm01, mm02, mm03, mm10, mm11, mm12, mm13, mm20, mm21, mm22, mm23, mm30, mm31, mm32, mm33: single)
  : TXMMATRIX; external;

implementation

{$R *.dfm}


procedure TdemoForm.btGOClick(Sender: TObject);
var
    retInt: integer;
    retSingle: single;
    retDouble: double;
    retInt64: int64;
    mm00, mm01, mm02, mm03, mm10, mm11, mm12, mm13, mm20, mm21, mm22, mm23, mm30, mm31, mm32, mm33: single;
    M: TXMMATRIX;
begin
    memo.Lines.Add('Adding: integer+single+smallint+byte. Result is integer');
    retInt := AddNumbersResInt(20000, 333.1, -450, 33);
    memo.Lines.Add(format('20000+333.1-450+33=%d', [retInt]));
    memo.Lines.Add('');

    memo.Lines.Add('Adding: integer+single+smallint+byte. Result is single');
    retSingle := AddNumbersResSingle(20000, 333.1, -450, 33);
    memo.Lines.Add(format('20000+333.1-450+33=%.1f', [retSingle]));
    memo.Lines.Add('');

    memo.Lines.Add('Multiply int64 by double, divide by uint 64. Result is double');
    retDouble := MulDivNumbersResDouble(-187650270809292, 7.23E23, $FFFF555544443334);
    memo.Lines.Add(format('(-187650270809292*7.23e23)/206414696598732=%1f', [retDouble]));
    memo.Lines.Add('');

    memo.Lines.Add('Multiply int64 by double, divide by uint 64. Result is int64');
    retInt64 := MulDivNumbersResInt64(-187650270809292, 7.23E23, $FFFF555544443334);
    memo.Lines.Add(format('(-187650270809292*7.23e23)/206414696598732=%d', [retInt64]));
    memo.Lines.Add('');

    mm00 := Random * 100 - 50;
    mm01 := Random * 100 - 50;
    mm02 := Random * 100 - 50;
    mm03 := Random * 100 - 50;
    mm10 := Random * 100 - 50;
    mm11 := Random * 100 - 50;
    mm12 := Random * 100 - 50;
    mm13 := Random * 100 - 50;
    mm20 := Random * 100 - 50;
    mm21 := Random * 100 - 50;
    mm22 := Random * 100 - 50;
    mm23 := Random * 100 - 50;
    mm30 := Random * 100 - 50;
    mm31 := Random * 100 - 50;
    mm32 := Random * 100 - 50;
    mm33 := Random * 100 - 50;

    memo.Lines.Add(format('Input 16 singles: %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f',
      [mm00, mm01, mm02, mm03, mm10, mm11, mm12, mm13, mm20, mm21, mm22, mm23, mm30, mm31, mm32, mm33]));

    M := XMMatrixSet(mm00, mm01, mm02, mm03, mm10, mm11, mm12, mm13, mm20, mm21, mm22, mm23, mm30, mm31, mm32, mm33);

    memo.Lines.Add('Output, 4x4 Matrix of Singles:');
    memo.Lines.Add(format('Row 0: %.1f %.1f %.1f %.1f', [M.r[0].vector4_f32[0], M.r[0].vector4_f32[1], M.r[0].vector4_f32[2],
      M.r[0].vector4_f32[3]]));
    memo.Lines.Add(format('Row 1: %.1f %.1f %.1f %.1f', [M.r[1].vector4_f32[0], M.r[1].vector4_f32[1], M.r[1].vector4_f32[2],
      M.r[1].vector4_f32[3]]));
    memo.Lines.Add(format('Row 2: %.1f %.1f %.1f %.1f', [M.r[2].vector4_f32[0], M.r[2].vector4_f32[1], M.r[2].vector4_f32[2],
      M.r[2].vector4_f32[3]]));
    memo.Lines.Add(format('Row 3: %.1f %.1f %.1f %.1f', [M.r[3].vector4_f32[0], M.r[3].vector4_f32[1], M.r[3].vector4_f32[2],
      M.r[3].vector4_f32[3]]));
    memo.Lines.Add('');
end;

procedure TdemoForm.FormCreate(Sender: TObject);
begin
    Randomize;
end;

end.
